#! /usr/bin/python2.7
# encoding: utf-8

# Copyright © 2016 Simon McVittie
#
# Permission is hereby granted, free of charge, to any person
# obtaining a copy of this software and associated documentation
# files (the "Software"), to deal in the Software without
# restriction, including without limitation the rights to use, copy,
# modify, merge, publish, distribute, sublicense, and/or sell copies
# of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be
# included in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
# HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
# WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
# DEALINGS IN THE SOFTWARE.

import sys

from gi.repository import GLib

import dbus
import dbus.mainloop.glib

if __name__ == '__main__':
    dbus.mainloop.glib.DBusGMainLoop(set_as_default=True)

    timed_out = False
    name = sys.argv[1]
    bus = dbus.SessionBus()
    loop = GLib.MainLoop()

    def time_out(*args):
        global timed_out
        timed_out = True
        loop.quit()

    GLib.timeout_add_seconds(30, time_out)

    def name_cb(owner):
        if owner:
            loop.quit()

    bus.watch_name_owner(name, name_cb)

    loop.run()

    if timed_out:
        raise SystemExit('timed out')
